blog/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('',views.index,name='index'),
    path('news/', views.news, name='news'),
    path ('search/',views.search_function,name="search_url"),
    path('news/<slug:slug>/',views.post_detail, name='post_detail_url'),
    path('news/<slug:slug>/comment/',views.comment, name='comment'),
    path('Categories/<slug:slug>/',views.category_detail, name='category_detail_url'),
    path('register/', views.register,name='register'),
    path('news/', views.news, name='news'),
    path('sort',views.sort,name='sort')
    
]

news/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('',include('blog.urls')),
    path('accounts/',include('django.contrib.auth.urls')),
] +static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

blog/models.py
from django.db import models
from django.utils import timezone
from django.shortcuts import reverse
from django.contrib.auth.models import User

class Category(models.Model):
    title = models.CharField('Загаловак',max_length=255)
    slug = models.SlugField('Ссылка',unique=True)
    image = models.ImageField('Картинка',blank=True, null=True)
    

    class Meta:
        verbose_name ='Категория'
        verbose_name_plural ='Категории'

    def get_absolute_url(self):
        return reverse('category_detail_url', kwargs={'slug':self.slug})

    def __str__(self):
        return self.title


class Post(models.Model):
    title = models.CharField('Загаловак',max_length=255)
    slug = models.SlugField('Ссылка',unique=True)
    image = models.ImageField('Картинка',blank=True, null=True)
    category = models.ForeignKey(Category, on_delete=models.SET_NULL,null=True,blank=True, verbose_name='Категория')
    content =models.TextField('Текст')
    date = models.DateTimeField('Дата',default =timezone.now)
    publish = models.BooleanField('Obublikovana',default = False)
    views = models.IntegerField('Просмотри',default=0)
    
    class Meta:
        verbose_name ='News'
        verbose_name_plural ='Новости'

    def get_absolute_url(self):
        return reverse('post_detail_url', kwargs={'slug':self.slug})

    def __str__(self):
        return self.title

class Comment(models.Model):
    user = models.ForeignKey(User, on_delete =models.CASCADE, verbose_name ='Автор')
    post = models.ForeignKey(Post, on_delete =models.CASCADE, verbose_name ='Новость')
    text = models.TextField('Текст комментария')
    date = models.DateTimeField('Дата',default=timezone.now)


    class Meta:
        verbose_name = 'Коментарии'
        verbose_name_plural = 'Коментарии'

    def __str__(self):
        return self.user.username

blog/forms.py
from django.contrib.auth.forms import UserCreationForm
from django import forms
from django.contrib.auth.models import User

class RegisterForm(UserCreationForm):
    username = forms.CharField(label="Nikname", required=True,widget=forms.TextInput(attrs={'class':'form-control mb-20'}))
    password1 = forms.CharField(label="Парол", required=True,widget=forms.PasswordInput(attrs={'class':'form-control mb-20'}))
    password2 = forms.CharField(label="Парол 2", required=True,widget=forms.PasswordInput(attrs={'class':'form-control mb-20'}))
    email = forms.EmailField(label="Маил", required=True,widget=forms.TextInput(attrs={'class':'form-control mb-20'}))
    first_name = forms.CharField(label="Имя", required=True,widget=forms.TextInput(attrs={'class':'form-control mb-20'}))
    last_name = forms.CharField(label="Фамилия", required=True,widget=forms.TextInput(attrs={'class':'form-control mb-20'}))

    class Meta:
        model = User
        fields = ('username','email','password1','password2','first_name','last_name',)
    
    def save(self,comit=True):
        user = super().save(comit=False)
        user.email = self.cleaned_data['email']
        user.first_name = self.cleaned_data['first_name']
        user.last_name = self.cleaned_data['last_name']
        if commit:
            user.save()
            return user

blog/views.py
from django.shortcuts import render, redirect, reverse
from .models import Post, Category
from django.db.models import Q
from .forms import RegisterForm


def news(request):
    posts = Post.objects.all()
    return render(request, 'blog/news.html', {'posts': posts})


def index(request):
    posts = Post.objects.filter(publish = 1).order_by('-views')[:3]
    sliders =Post.objects.filter(publish = 1).filter(views__gte = 10).order_by('-views')[:6]
    categories = Category.objects.order_by('-id')[:12]
    context = {'news':posts,'sliders':sliders,'categories': categories}
    return render(request, 'blog/index.html', context ) #project/app/templates/blog/index.html
    

def search_function(request):
    query = request.GET.get('search_input')
    posts = Post.objects.filter(Q(title__icontains = query))
    return render(request, 'blog/search.html',{'query': query,'posts':posts})

def post_detail(request,slug):
    post = Post.objects.get(slug__exact = slug)
    post.views +=1
    post.save()
    return render(request, 'blog/post_detail.html',{'post':post})

def category_detail(request,slug):
    category = Category.objects.get(slug__exact = slug)
    return render(request, 'blog/category_detail.html',{'category': category})

def register(request):
    if  not request.user.is_authenticated:
        if request.method =='POST':
            form = RegisterForm(request.POST)
            if form.is_valid():
                form.save()
                return redirect('login')
        else:
            form = RegisterForm()
        return render(request, 'blog/register.html',{'form':form})
    return redirect('index')

def comment(request,slug):
    post = Post.objects.get(slug__exact = slug)
    if request.method == 'POST': 
        post.comment_set.create(
            user = request.user,
            text = request.POST.get('text')
             )
        return redirect(reverse('post_detail_url', kwargs={'slug': post.slug}))
    return redirect(reverse('post_detail_url',kwargs={'slug': post.slug}))

def sort(request):
    query = request.GET.get('sort')
    posts = Post.objects.order_by(query)
    return render(request,'blog/sort.html',{'posts':posts,'query':query})

blog/templates/blog/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <!-- <link rel="stylesheet" href="{% static 'css.css' %}"> -->
    <link rel="stylesheet" href=" {% static 'bootstrap.min.css' %}">
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <a class="logo" ><img style="height: 80px; width: 80px;" src="https://icons.iconarchive.com/icons/pelfusion/long-shadow-ios7/1024/News-icon.png" alt=""></a>
        <a class="navbar-brand" href="#" style="color: blue" >Euro<span style="color: darkblue;">news.</span></a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
      
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
          <ul class="navbar-nav mr-auto">
            <li class="nav-item">
              <a href="{% url 'index'%}" class="nav-link">Главное</a>
            </li>
            <li class="nav-item">
              <a href="{% url 'news'%}" class="nav-link">Новости</a>
            </li>
            {% if not user.is_authenticated %}
            <li class="nav-item">
              <a href="{% url 'register'%}" class="nav-link">Регистация</a>
            </li>
            <li class="nav-item">
              <a href="{% url 'index'%}" class="nav-link">Вход</a>
            </li>
            {% else %}
            <li class="nav-item">
              <a href="{% url 'index'%}" class="nav-link">Выход</a>
            </li>
            {% endif %}
            <li class="nav-item">
              <a class="nav-link disabled" href="#" tabindex="-1" aria-disabled="true">Бизнес</a>
            </li>
          </ul>
          <form action="{% url 'search_url' %}" method="GET" class="form-inline my-2 my-lg-0">
            <input name='search_input' class="form-control mr-sm-2" type="search" placeholder="Поиск..." aria-label="Search">
            <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Поиск</button>
          </form>
        </div>
      </nav>
      
    {% block  content %}
    {% endblock %}
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
    <script src="{%  static 'bootstrap.min.js' %}"></script>
</body>
</html>

blog/templates/blog/category_detail.html
{% extends 'blog/base.html' %}

{% block title %}
{{category.title}}

{% endblock %}

{% block content %}
    <div class="container">
        <div class="row">
            <div class="col-md-9" style="padding: 20px;">
                {% if post.image.url != null %}
                <img src="{{category.image.url}}" style="width: 100%; height: 300px; object-fit: cover;" alt="">
                {% endif %}
                <h3>{{ category.title }}</h3><hr>
                <div class="row">
                    {% for post in category.post_set.all %}
                    <div class="col-md-4">
                      <div class="card">
                        {% if post.image.url != null %}
                        <img style="height: 250px; object-fit: cover;" src="{{post.image.url}}" class="card-img-top" alt="...">
                        {% endif %}
                        <div class="card-body">
                          <h5 class="card-title">{{post.title}}</h5>
                          <p class="card-text">{{post.content|safe|slice:'0:100'}}...</p>
                          <a href="{{post.category.get_absolute_url}}" class="btn btn-primary">{{post.category.title}}</a>
                        </div>
                      </div>
                    </div>
                    {% endfor %}
                </div>
                
            </div>
            <div class="col-md-3"></div>
        </div>
    </div>
{% endblock %}

blog/templates/blog/index.html
{% extends 'blog/base.html' %}

{% block content %}
<section class="news">
    <aside class="left">
        <div id="carouselExampleCaptions" class="carousel slide" data-ride="carousel">
            <ol class="carousel-indicators">
              {% for post in sliders%}
              <li  data-target="#carouselExampleCaptions" data-slide-to="{{forloop.counter0}}" {% if forloop.first %} class="active"{% endif %}></li>
              {% endfor %}
            </ol>
            <div class="carousel-inner">
              {% for post in sliders %}
              <div class="carousel-item {% if forloop.first %} active {% endif %}">
                {% if post.image.url != null %}
                <img  style="height: 500px; object-fit: cover" src="{{post.image.url}}" class="d-block w-100" alt="...">
                {% endif %}
                <div class="carousel-caption d-none d-md-block">
                  <a href="{{post.get_absolute_url}}">
                    <h5>{{ post.title}}</h5>
                  </a>
                  
                  <p>{{post.content|safe|slice:'0:100'}}</p>

                </div>
              </div>
              {% endfor %}
            </div>
            <a class="carousel-control-prev" href="#carouselExampleCaptions" role="button" data-slide="prev">
              <span class="carousel-control-prev-icon" aria-hidden="true"></span>
              <span class="sr-only">Previous</span>
            </a>
            <a class="carousel-control-next" href="#carouselExampleCaptions" role="button" data-slide="next">
              <span class="carousel-control-next-icon" aria-hidden="true"></span>
              <span class="sr-only">Next</span>
            </a>
          </div>
    </aside>
<section class='container-fluid'>
  <div class="container">
    <h1 class="text-center"> Популярные новости</h1>
    <hr>
    <div class="row">
      {% for post in news %}
      <div class="col-md-4">
        <div class="card">
          {% if post.image.url != null %}
          <img style="height: 250px; object-fit: cover;" src="{{post.image.url}}" class="card-img-top" alt="...">
          {% endif %}
          <div class="card-body">
            <h5 class="card-title">{{post.title}}</h5>
            <p class="card-text">{{post.content|safe|slice:'0:100'}}...</p>
            <b>Просмотров: {{post.views}}</b>
            <a href="{{post.category.get_absolute_url}}" class="btn btn-primary">{{post.category.title}}</a>
          </div>
        </div>
      </div>
      {% endfor %}
    </div>
  </div>
</section>
<section class="container-fluid bg light">
  <div class="container">
    <h2 class="text-center">Bukhara city</h2><hr>
    <div class="row">
      <div class="col-md-3">
        <div class="card">
          <img src="https://www.gazeta.uz/media/img/2019/04/jfkdp415541953313821_b.jpg" class="card-img-top" alt="...">
          <div class="card-body">
            <p class="card-text">Some quick example text to build on the card title and make up the bulk of the card's content.</p>
          </div>
        </div>
      </div>
      <div class="col-md-3">
        <div class="card">
          <img src="https://i0.wp.com/www10.aeccafe.com/blogs/arch-showcase/files/2019/05/05_14.jpg?ssl=1" class="card-img-top" alt="...">
          <div class="card-body">
            <p class="card-text">Some quick example text to build on the card title and make up the bulk of the card's content.</p>
          </div>
        </div>
      </div>
      <div class="col-md-3">
        <div class="card">
          <img src="https://i0.wp.com/www10.aeccafe.com/blogs/arch-showcase/files/2019/05/04_3.jpg?ssl=1" class="card-img-top" alt="...">
          <div class="card-body">
            <p class="card-text">Some quick example text to build on the card title and make up the bulk of the card's content.</p>
          </div>
        </div>
      </div>
      <div class="col-md-3">
        <div class="card">
          <img src="https://uzbektourism.uz/uploads/images/901new.png" class="card-img-top" alt="...">
          <div class="card-body">
            <p class="card-text">Some quick example text to build on the card title and make up the bulk of the card's content.</p>
          </div>
        </div>
      </div>
      
      <section class="container-fluid bg light">
        <div class="container">
          <div class="row">
            <div class="col-md-8">
              <div class="card">
                <img src="https://i.ytimg.com/vi/SCYWfvuZZ1Y/maxresdefault.jpg" class="card-img-top" alt="...">
                <div class="card-body">
                  <p class="card-text">Some quick example text to build on the card title and make up the bulk of the card's content.</p>
                </div>
              </div>
            </div>
            <div  class="col-md-4">
              <div class="card">
                <img src="https://i.ytimg.com/vi/SCYWfvuZZ1Y/maxresdefault.jpg" class="card-img-top" alt="...">
                <div class="card-body">
                  <p class="card-text">Some quick example text to build on the card title and make up the bulk of the card's content.</p>
                </div >
              </div>
            </div>
            
          </div>
        </div>
      </section>
      

     
      <main class="container-fluid">
        <div class="container">
          <div class="row">
            <div class="col-md-9">
              <div id="carouselExampleControls" class="carousel slide" data-ride="carousel">
                <div class="carousel-inner">
                  <div class="carousel-item active">
                    <img style="height: 450px;" src="https://www.androidcentral.com/sites/androidcentral.com/files/styles/large_wm_brw/public/article_images/2020/08/samsung-galaxy-note-20-ultra-review-3.jpg" class="d-block w-100" alt="...">
                    <p>Lorem, ipsum dolor sit amet consectetur adipisicing elit. Reprehenderit temporibus excepturi, et nihil, quae laudantium porro deserunt, in quasi omnis quas recusandae inventore dignissimos rem cupiditate ipsa eius? Quae, dolores.</p>
                  </div>
                  <div class="carousel-item">
                  <a href="{{category.get_absolute_url}}">
                  
                    <img src="https://chudo.tech/wp-content/uploads/2019/11/iPhone-11-Pro-Max.jpg" class="d-block w-100" alt="...">
              
                    <img src="#" alt="{{category.title}}" class="card-img-top">
                    <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Iste distinctio odio nesciunt quisquam animi veritatis magnam id sit consectetur odit quas repellendus culpa ad debitis, consequatur est quasi eius assumenda.</p></a>
                    
                  </div>
                  <div class="carousel-item">
                    <img src="https://mobile-review.com/articles/2020/image/press-huawei-p40-series/08.jpg" class="d-block w-100" alt="...">
                  <p>Lorem ipsum, dolor sit amet consectetur adipisicing elit. Impedit officiis doloribus eius iste sunt distinctio, deserunt consequuntur! Expedita fugiat amet explicabo commodi beatae quasi nulla dicta, ab sequi doloremque accusantium?</p>
                  </div>
                </div>
                <a class="carousel-control-prev" href="#carouselExampleControls" role="button" data-slide="prev">
                  <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                  <span class="sr-only">Previous</span>
                </a>
                <a class="carousel-control-next" href="#carouselExampleControls" role="button" data-slide="next">
                  <span class="carousel-control-next-icon" aria-hidden="true"></span>
                  <span class="sr-only">Next</span>
                </a>
              </div>
            </div>
            <div class="col-md-3">
              <div class="row">
                <div class="col-md-6">
                  <img style="width: 100%;" src="https://cnet3.cbsistatic.com/img/hLHi09i5lA43a6RvRzhiUKMkBAU=/940x0/2020/06/09/8ed3b28b-a136-44b8-a798-c41b9806af55/p40-pro-plus-product.jpg" alt="">
                 <p>
                   Lorem ipsum dolor, sit amet consectetur adipisicing elit. Ratione, soluta.
                 </p>
                 <div class="col-md-6"></div>
                 <img style="width: 100%;" src="https://superg.ru/wp-content/uploads/2020/04/Huawei-P40-Pro-7.jpg" alt="">
                 <p>
                   Lorem ipsum dolor sit amet consectetur adipisicing elit. Nam, vitae!
                 </p>
               </div>
               <div class="col-md-6">
                <img style="width: 100%;" src="https://cnet3.cbsistatic.com/img/hLHi09i5lA43a6RvRzhiUKMkBAU=/940x0/2020/06/09/8ed3b28b-a136-44b8-a798-c41b9806af55/p40-pro-plus-product.jpg" alt="">
               <p>
                 Lorem ipsum dolor, sit amet consectetur adipisicing elit. Ratione, soluta.
               </p>
               <div class="col-md-6"></div>
               <img style="width: 100%;" src="https://superg.ru/wp-content/uploads/2020/04/Huawei-P40-Pro-7.jpg" alt="">
               <p>
                 Lorem ipsum dolor sit amet consectetur adipisicing elit. Nam, vitae!
               </p>
             </div>
              </div>
                         
            </div>
          </div>
        </div>
      </main>

      
{% endblock %}

blog/templates/blog/news.html
{% extends 'blog/base.html' %}

{% block title %}
Поиск по запросу: {{query}}
{% endblock %}

{% block content %}
<div class="container">
    <div class="row">
        <div class="col-md-9">
            <div class="row">
                {% for post in posts %}
                    <div class="col-md-4">
                        {% if post.image.url != null %}
                        <img src="{{post.image.url}}" style="height: 200px; width: 100%; object-fit: cover" alt="">
                        {% endif %}
                        <h3 class="text-center">{{post.title}}</h3>
                    </div>
                {% empty %}
                <h2>По запросу "{{query}}" ничего не найдено!</h2>
                {% endfor %}
            </div>
        </div>
        <div class="col-md-3">
        
            <form action="{% url 'sort' %}" method="GET">
                <select name="sort" onchange="{this.form.submit()}">
                    <option value="date">Сначало новые</option>
                    <option value="date">Сначало старые</option>
                    <option value="-views">Популярный</option>
                    <option value="views">Непопуляный</option>
                </select>
            </form>
        </div>
    </div>
</div>
{% endblock %}

blog/templates/blog/post_detail.html
{% extends 'blog/base.html' %}
{% load humanize %}

{% block title %}
{{post.title}}

{% endblock %}

{% block content %}
    <div class="container">
        <div class="row">
            <div class="col-md-9" style="padding: 20px;">
                {% if post.image.url != null %}
                <img src="{{post.image.url}}" style="width: 100%;" alt="">
                {% endif %}
                <h3>{{ post.title }}</h3>
                <p>{{ post.content|safe}}</p>
                <p class="text-right">
                    <b>Просмотри: {{post.views}}</b> |
                    <i>{{ post.date|date:"d F, Y"}}</i>
                </p>
                <hr>
                <p>
                    <i>Комментарии: {{post.comment_set.count}}</i>

                </p>
                <h3>Оставьте ваш комментприи</h3>
                {% if user.is_authenticated %}
                <form action="{% url 'comment' post.slug %}" method="POST">
                    {% csrf_token %}
                    <p>
                        <textarea name="text" class="form-control"></textarea>
                    </p>
                    <p class="text-right">
                        <button class="btn btn-outline-primary">Отправить</button>

                    </p>
                </form>
                {% else %}
                <p>Чтобы оставить коментарии</p>, <a href="{% url 'register' %}">Зарегиструйтесь</a> или <a href="{% url 'login' %}">Войдите</a>
                {% endif %}
                <hr>
                {% for comment in post.comment_set.all %}
                <div class="col-md-12">
                    <h3>{{comment.user.username}}</h3>
                <p>
                    {{comment.text}}
                </p>
                <p class="text-right">
                    {{comment.date|timesince}} назад
                </p>
                </div>
                {% endfor %}
            </div>
            <div class="col-md-3"></div>
        </div>
    </div>
{% endblock %}

blog/templates/blog/register.html
{% extends 'blog/base.html' %}

{% block title %}
Регистрация

{% endblock %}

{% block content %}
<div class="container">
    <div class="row">
        <div class="col-md-9">
            <form action="{%url 'register' %}"method="POST">
                {% csrf_token %}
                {{form.as_p}}
                <button class="btn btn-success">Регистрация</button>
            </form>
        </div>
        <div class="col-md-3"></div>
    </div>
</div>
{% endblock %}

blog/templates/blog/search.html
{% extends 'blog/base.html' %}

{% block title %}
Поиск по запросу: {{query}}

{% endblock %}

{% block content %}
<div class="container">
    <div class="row">
        <div class="col-md-9">
            <div class="row">
                {% for post in posts %}
                    <div class="col-md-4">
                        {% if post.image.url != null %}
                        <img src="{{post.image.url}}" style="height: 200px; width: 100%; object-fit: cover;" alt="">
                        {% endif %}
                        <h3 class="text center">{{post.title}}</h3>
                    </div>
                    {% empty %}
                    <h2>По запросу *{{query}}* нечего не найдено</h2>
                {% endfor  %}
            </div>
           
        </div>
        <div class="col-md-3"></div>
    </div>
</div>
{% endblock %}

blog/templates/blog/sort.html
{% extends 'blog/base.html' %}

{% block title %}
Поиск по запросу: {{query}}
{% endblock %}

{% block content %}
<div class="container">
    <div class="row">
        <div class="col-md-9">
            <div class="row">
                {% for post in posts %}
                    <div class="col-md-4">
                        {% if post.image.url != null %}
                        <img src="{{post.image.url}}" style="height: 200px; width: 100%; object-fit: cover" alt="">
                        {% endif %}
                        <h3 class="text-center">{{post.title}}</h3>
                    </div>
                {% empty %}
                <h2>По запросу "{{query}}" ничего не найдено!</h2>
                {% endfor %}
            </div>
        </div>
        <div class="col-md-3">
        
            <form action="{% url 'sort' %}" method="GET">
                <select name="sort" onchange="{this.form.submit()}">
                    <option {% if query == '-date' %} selected {% endif %} value="-date">Сначало новые</option>
                    <option {% if query == 'date' %} selected {% endif %} value="date">Сначало старые</option>
                    <option {% if query == '-views' %} selected {% endif %} value="-views">Популярный</option>
                    <option {% if query == 'views' %} selected {% endif %} value="views">Непопуляный</option>
                    </select>
            </form>
        </div>
    </div>
</div>
{% endblock %}